#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <fcntl.h>
#include <alloc.h>
#include "modex.h"

byte far *charset; //Verbesserter Zeichensatz
byte ansi[255];
byte laenge[91];
unsigned scroff=0;

void loadfont()
{
 unsigned i;
 byte chars[85][9*13+4];
 byte *pchars;

 FILE *fn;
 charset=(byte far*)farmalloc(10300);

 fn=fopen("char.dat","rb");
 fread(chars,1,85*(9*13+4),fn);
 fread(ansi,1,255,fn);
 fread(laenge,1,90,fn);
 fclose(fn);

 pchars=&(chars[0][0]);
 for (i=0; i<10285; i++)
  charset[i]=pchars[i];

 ansi[148]=78;
 ansi[132]=79;
 ansi[129]=80;
 ansi[225]=81;
 ansi[153]=82;
 ansi[142]=83;
 ansi[154]=84;

}

void aprint(int x, int y, byte col, unsigned scroff, unsigned char *string)
{
 int i;
 word xx,fl,l,sl,c,ms,mo,ca,cb;
 word scrof;

 laenge[60]=4;

 scrof=scroff+y*80;

 asm{mov ax,0xa000
     mov fs,ax};

 sl=strlen(string);
 ca=12*80;
 xx=x;
 ms=FP_SEG(charset);
 asm{mov ax,ms
     mov gs,ax};

 for(i=0; i<sl; i++)
 {
  c=ansi[string[i]];
  fl=l=laenge[c];
  mo=FP_OFF(charset)+c*121;

  cb=12*l-1;
  x+=l;

  asm{mov si,mo
      add si,2};
lb2:
  asm{mov di,scrof
      mov ax,xx
      mov cx,ax
      shr ax,2
      add di,ax
      mov bl,col
      and cx,3
      mov ax,1
      shl ax,cl
      mov dx,TS
      mov ah,al
      mov al,2
      out dx,ax
      mov cx,12};
lb1:
  asm{mov al,gs:[si]
      or al,al
      jz noplot
      mov fs:[di],bl};
noplot:
  asm{add di,80
      add si,fl
      dec cx
      jnz lb1
      //sub di,ca
      sub si,cb
      inc word ptr xx
      dec word ptr l
      jnz lb2};
  xx=x;
 }
}

void bprint(int x, int y, byte col, unsigned scrof, unsigned char *string)
{
 unsigned xxx,yyy,ccc;
 int xx;
 int i,j,k;
 int c;

 scroff=scrof;
 xx=x;

 laenge[60]=4;

 asm{MOV AX,0xa000
     MOV FS,AX};
 for(i=0; i<strlen(string); i++)
 {
  c=ansi[string[i]];
  for (j=0; j<laenge[c]; j++)
   for (k=0; k<12; k++)
    if (charset[c*121+(2+j+k*laenge[c])])
    {
    asm{MOV BX,xx
	ADD BX,j
	PUSH BX
	MOV DI,scroff
	MOV CX,3
	AND CX,BX
	MOV BX,1
	SHL BX,CL
	MOV DX,TS
	MOV AL,0x02
	MOV AH,BL
	OUT DX,AX
	MOV AX,y
	ADD AX,k
	MOV BX,AX
	SHL AX,6
	SHL BX,4
	ADD AX,BX
	ADD DI,AX
	POP AX
	SHR AX,2
	ADD DI,AX
	MOV AL,col
	MOV FS:[DI],AL}
  }
  xx+=laenge[c];
 }
}

void destroyfont()
{
 farfree (charset);
}

void paint (int x1, int y1, int x2, int y2, unsigned scrof, byte col)
{
 register unsigned int x;

 for (x=x1; x<x2; x++)
  yline(y1,y2,x,col,scrof);
}
