#include <dos.h>

typedef unsigned char byte;

typedef struct {byte attack1,attack2,decay1,decay2,sustian1,sustian2;
		byte release1,release2,susts1,susts2,volume1,volume2;
		byte evenlope1, evenlope2, scaling1, scaling2;
		byte fmultiplier1,fmultiplier2,wave1,wave2,pitch1,pitch2;
		byte addsynth, feedback;} TON;

/*
byte vol1[10];           //0-63    0x40     bit0-5
byte vol2[10];           //0-63    0x40+3
byte lscaling1[10];      //0-3     0x40     bit6-7
byte lscaling2[10];      //0-3     0x40+3
byte scalee1[10];        //0/1     0x20     bit4
byte scalee2[10];        //0/1     0x20+3
byte sus1[10];           //0/1     0x20     bit5
byte sus2[10];           //0/1     0x20+3
byte fmultiplier1[10];   //0-15    0x20     bit0-3
byte fmultiplier2[10];   //0-15    0x20+3
byte vvip1[10];          //0/1     0x20     bit6
byte vvip2[10];          //0/1	   0x20+3
*/
byte ton[13][3];         //
byte channel[10];        //1-9
byte x201[10];
byte x202[10];
byte x401[10];
byte x402[10];

void setreg(byte reg,byte val)
{
 asm {MOV DX,0x0388
      MOV AL,reg
      OUT DX,AL
      MOV CX,7};
 w1:
 asm {IN AL,DX
      LOOP w1
      INC DX
      MOV AL,val
      OUT DX,AL
      MOV CX,36
      DEC DX};
 w2:
 asm {IN AL,DX
      LOOP w2};
}

void setall()
{
 ton[1][1]=0x01;       // values for the staff
 ton[1][2]=0x6b;
 ton[2][1]=0x01;
 ton[2][2]=0x81;
 ton[3][1]=0x01;
 ton[3][2]=0x98;
 ton[4][1]=0x01;
 ton[4][2]=0xb0;
 ton[5][1]=0x01;
 ton[5][2]=0xca;
 ton[6][1]=0x01;
 ton[6][2]=0xe5;
 ton[7][1]=0x02;
 ton[7][2]=0x03;
 ton[8][1]=0x02;
 ton[8][2]=0x20;
 ton[9][1]=0x02;
 ton[9][2]=0x41;
 ton[10][1]=0x02;
 ton[10][2]=0x63;
 ton[11][1]=0x02;
 ton[11][2]=0x87;
 ton[12][1]=0x02;
 ton[12][2]=0xae;

 channel[1]=0x00;
 channel[2]=0x01;
 channel[3]=0x02;
 channel[4]=0x08;
 channel[5]=0x09;
 channel[6]=0x0a;
 channel[7]=0x10;
 channel[8]=0x11;
 channel[9]=0x12;
}

int detectadlib()
{
 register byte st1,st2;

 setreg(0x04,0x60);
 delay(20);
 setreg(0x04,0x80);
 st1=inportb(0x0388);
 setreg(0x02,0xff);
 setreg(0x04,0x21);
 delay(85);
 st2=inportb(0x0388);
 setreg(0x04,0x60);
 delay(20);
 setreg(0x04,0x80);
 setall();
 if ((st1 & 0xe0)==0 && (st2 & 0xe0)==0xc0)
  { setall();
    for (st1=0; st1<=254; st1++)
     setreg(st1,0);
    setreg(0x01,0x20);
    return 1;
  }
 return 0;
}

void sbsound(byte voice, byte staff, byte octave)
{
 byte a,help;
 byte register x;

 switch (staff)
 {
  case 'C': x=1; break;
  case 'd': x=2; break;
  case 'D': x=3; break;
  case 'e': x=4; break;
  case 'f': x=5; break;
  case 'F': x=6; break;
  case 'g': x=7; break;
  case 'G': x=8; break;
  case 'a': x=9; break;
  case 'A': x=10; break;
  case 'b': x=10; break;
  case 'h': x=11; break;
  case 'c': x=12; break;
 }
 a=channel[voice];
 setreg(0x40+a,x401[voice-1]);
 setreg(0x43+a,x402[voice-1]);
 setreg(0x20+a,x201[voice-1]);
 setreg(0x23+a,x202[voice-1]);
 setreg(0xa0+voice-1,ton[x][2]);
 setreg(0xb0+voice-1,0x30+ton[x][1]+(octave<<2));
}

void sbnosound(byte voice)
{
 setreg(0xb0+voice-1,0x00);
}

void setup(byte voice,TON *a)
{
 setreg (0xc0+voice-1,(a->addsynth&1)+((a->feedback&7)<<1));
 setreg (0x60+channel[voice],((a->attack1&15)<<4)+(a->decay1&15));
 setreg (0x80+channel[voice],((a->sustian1&15)<<4)+(a->release1&15));
 setreg (0x63+channel[voice],((a->attack2&15)<<4)+(a->decay2&15));
 setreg (0x83+channel[voice],((a->sustian1&15)<<4)+(a->release2&15));
 setreg (0xe0+channel[voice],a->wave1&3);
 setreg (0xe3+channel[voice],a->wave2&3);
/* sus1[voice-1]=a->susts1&1;
 sus2[voice-1]=a->susts2&1;
 vol1[voice-1]=a->volume1&63;
 vol2[voice-1]=a->volume2&63;
 scalee1[voice-1]=a->evenlope1&1;
 scalee2[voice-1]=a->evenlope2&1;
 lscaling1[voice-1]=a->scaling1&3;
 lscaling2[voice-1]=a->scaling2&3;
 fmultiplier1[voice-1]=a->fmultiplier1&15;
 fmultiplier2[voice-1]=a->fmultiplier2&15;
 vvip1[voice-1]=a->pitch1&1;
 vvip2[voice-1]=a->pitch2&1;     */
 x401[voice-1]=((a->scaling1&3)<<6)+(a->volume1&63);
 x402[voice-1]=((a->scaling2&3)<<6)+(a->volume2&63);
 x201[voice-1]=(a->fmultiplier1&15)+((a->pitch1&1)<<7)+((a->susts1&1)<<6)+
	       ((a->evenlope1&1)<<5);
 x202[voice-1]=(a->fmultiplier2&15)+((a->pitch2&1)<<7)+((a->susts2&1)<<6)+
	       ((a->evenlope2&1)<<5);
}

void playakkord(byte base,char dur,byte okt)
{
 byte a,b,c;
 dur=dur & 1;
 a=base;
 if (dur==0)
  switch (base)
  {
   case 'c': b='e'; c='g'; break;
   case 'd': b='F'; c='a'; break;
   case 'e': b='G'; c='h'; break;
   case 'f': b='a'; c='c'; break;
   case 'g': b='h'; c='d'; break;
   case 'a': b='C'; c='e'; break;
   case 'h': b='D'; c='F'; break;
   case 'b': b='d'; c='f'; break;
   case 'C': b='f'; c='G'; break;
   case 'D': b='g'; c='b'; break;
   case 'F': b='A'; c='C'; break;
   case 'G': b='c'; c='D'; break;
  }
 else
  switch (base)
  {
   case 'c': b='D'; c='g'; break;
   case 'd': b='f'; c='a'; break;
   case 'e': b='g'; c='h'; break;
   case 'f': b='G'; c='C'; break;
   case 'g': b='b'; c='d'; break;
   case 'a': b='c'; c='e'; break;
   case 'h': b='d'; c='F'; break;
   case 'b': b='C'; c='F'; break;
   case 'C': b='e'; c='G'; break;
   case 'D': b='F'; c='A'; break;
   case 'F': b='a'; c='C'; break;
   case 'G': b='h'; c='D'; break;
  }
 sbsound(9,a,okt);
 sbsound(8,b,okt);
 sbsound(7,c,okt);
}

void setf(int freq, byte voice)
{
 register unsigned char lo,hi;
 register int oct;
 register byte lp;

 oct=5;
 lp=1;
 do
 {
  lo=freq&255;
  hi=freq>>8;

  if (hi>3)
  {
   oct++;
   freq=(freq>>1);
  }
  else
   lp=0;
 }while(lp);


 setreg(0xa0+(voice-1),lo);
 setreg(0xb0+(voice-1),32+(oct<<2)+hi);
}
