
#define CRTC 0x3d4
#define TS 0x3c4
#define GDC 0x3ce
#define DAC 0x3c6

typedef unsigned char byte;
typedef unsigned int  word;

typedef struct {byte kenn,ver,rle,bpp;
		word xlo,ylo,xru,yru,xdpi,ydpi;
		byte pal16[48];
		byte r,planes;
		word bpb,palette;
		byte reserved[58];} PCX;

byte getkeyb();

void setmodex ();
void viewpage (char page);
void settext();
void use400();
void setlstart(word start);
void clear (char page);


void rgb(int x,char r,char g,char b);
void dark(int tim);
void raster();
byte MYpeek (word s,word o);
void MYpoke (word s,word o, byte value);
void box (int x1, int y1, int x2, int y2, byte col, byte page);



void putpixel (int x, int y,byte col, int page);
byte getpixel (int x, int y, int page);
void fastpp (int x, int y, byte col, word scrof);
void xline (word xa, word xe, word y, byte col, unsigned scrof);
void yline (word ya, word ye, word x, byte col, unsigned scrof);
void line (int x1, int y1, int x2, int y2, byte col, int page);
void copyscreen (word quelle, word ziel);
void usercopyscreen (word quelle, word ziel, word count);


byte far* getxsprite (word x, word y, word xl, word yl, char page);
void putxsprite (word x, word y, word scroff, byte far *data);
void putosprite (int x, int y, byte page, byte far *data);
void getsprite (word x, word y, word xl, word yl, char page, byte far *z);
//void getsprite (word x, word y, word xl, word yl, char page, byte far *z);

byte far* loadchar(unsigned char *name);
void print (int x,int y, unsigned char col, char page, char *string,
	    byte reverse, byte far *character);
void input(int x, int y, byte col, char page,
	   byte far *string, byte lengh, byte far *zchn);

int len (char *string);

int loadpcx(word x, word y,char *filename, PCX *header, unsigned scrof);
void getpcxinfo(char *filename, PCX *header);
void onscreen();
void offscreen();

void scr2mem(unsigned scrof,byte far *mem, unsigned length);
void mem2scr(byte far*mem, unsigned scrof, unsigned length);


void putmcsprite (word x, word y, word scroff, byte color,byte far *data);
void putxshape (word x, word y, unsigned scroff, byte far *data);


#define rectangle(x1,y1,x2,y2,col,scrof); {yline(y1,y2,x2,col,scrof); \
					   yline(y1,y2,x1,col,scrof); \
					   xline(x1,x2,y1,col,scrof); \
					   xline(x1,x2,y2,col,scrof);}
